package de.kybeidos.switchyard.sasauto;


import org.jasypt.encryption.pbe.StandardPBEStringEncryptor;
import org.switchyard.component.bean.Property;
import org.switchyard.component.bean.Service;

import de.kybeidos.switchyard.sasauto.interfaces.ConnectionSettingsService;
import de.kybeidos.switchyard.sasauto.model.ConnectionSettings;
import de.kybeidos.switchyard.sasauto.model.ServiceCommandRequest;
import javax.inject.Named;

@Named
@Service(ConnectionSettingsService.class)
public class ConnectionSettingsServiceBean implements ConnectionSettingsService {
	
	@Property(name="host")
	private String host;
	@Property(name="port")
	private String port;
	@Property(name="username")
	private String username;
	@Property(name="pwd")
	private String pwd;
	
	
	// Old operation, not used any more???
	@Override
	public ConnectionSettings replaceNullsAndAddDefaults(
			ConnectionSettings input) {
		StandardPBEStringEncryptor decryptor=new StandardPBEStringEncryptor();
		decryptor.setPassword("kybeidos2013");
		ConnectionSettings result=new ConnectionSettings();
		result.setHostname((input!=null && input.getHostname()!=null)?input.getHostname():host);
		result.setPortNumber((input!=null && input.getPortNumber()!=null)?input.getPortNumber():Integer.parseInt(port));
		result.setPwd((input!=null && input.getPwd()!=null)?decryptor.decrypt(input.getPwd()):decryptor.decrypt(pwd));
		result.setUsername((input!=null && input.getUsername()!=null)?input.getUsername():username);

		// TODO Auto-generated method stub
		return result;
	}

	@Override
	public <T extends ServiceCommandRequest> T addDefaults(T input) {
		StandardPBEStringEncryptor decryptor=new StandardPBEStringEncryptor();
		decryptor.setPassword("kybeidos2013");
		ConnectionSettings in=(input!=null)?input.getConnectionSettings():null;
		ConnectionSettings result=new ConnectionSettings();
		result.setHostname((in!=null && in.getHostname()!=null)?in.getHostname():host);
		result.setPortNumber((in!=null && in.getPortNumber()!=null)?in.getPortNumber():Integer.parseInt(port));
		result.setPwd((in!=null && in.getPwd()!=null)?decryptor.decrypt(in.getPwd()):decryptor.decrypt(pwd));
		result.setUsername((in!=null && in.getUsername()!=null)?in.getUsername():username);

		input.setConnectionSettings(result);
		// TODO Auto-generated method stub
		return input;
		
	}


}
