package de.kybeidos.switchyard.sasauto;

import java.io.File;

import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;

import de.kybeidos.switchyard.sasauto.model.TransferFileRequest;
import de.kybeidos.switchyard.sasauto.model.TransferFileResult;
import de.kybeidos.switchyard.tools.SCPFrom;

public class FTPSTransferService extends RouteBuilder {

	private static final String remoteUser="gost";
	private static final String remoteHost="localhost";
	private static final String remoteParams="/?";
	private static final String remotePassword="6057gost";
	private static final String remotePort="22";
	private static final String remoteProtocol="sftp://";
	/**
	 * The Camel route is configured via this method.  The from:
	 * endpoint is required to be a SwitchYard service.
	 */
	public void configure() {
		// TODO Auto-generated method stub
		from("switchyard://FileTransfer")
		.log("mentered brate, ${body.transferType}")
		.choice()
			.when(simple("${body.transferType} == 'upload'"))
				.log("From ${body.sourcePath} ${body.sourceFileName}")
				.log("to ${body.destinationPath} ${body.destinationFileName}")
				.setHeader("CamelFileName", simple("${body.destinationFileName}"))
				.process(new Processor() {
					public void process(final Exchange exchange) throws Exception {
						// get the filename from our custome header we want to get from a remote server
						TransferFileRequest message = exchange.getIn().getBody(TransferFileRequest.class);

						// construct the total url for the ftp consumer
						String url = message.getSourcePath() + message.getSourceFileName();

						exchange.getIn().setBody(new File(url));
					}
				})
				.to(remoteProtocol+remoteUser+"@"+remoteHost+":"+remotePort+remoteParams+"password="+remotePassword)
				.process(new Processor() {
					public void process(final Exchange exchange) throws Exception {
						// get the filename from our custome header we want to get from a remote server
						File message = exchange.getIn().getBody(File.class);

						// construct the total url for the ftp consumer
						TransferFileResult response=new TransferFileResult();
						if (message.isFile() || message.exists()){
							response.setSuccess(true);
						} else {
							response.setSuccess(false);
							response.setErrorDescription("not succeeded");
						}

						exchange.getOut().setBody(response);
					}
				})				
			.when(simple("${body.transferType} == 'download'"))
				.log("From ${body.sourcePath} ${body.sourceFileName}")
				.log("to ${body.destinationPath} ${body.destinationFileName}")
				.setHeader("CamelFileName", simple("${body.destinationFileName}"))
				.process(new Processor() {
					public void process(final Exchange exchange)  {
						// get the filename from our custome header we want to get from a remote server
						TransferFileRequest message = exchange.getIn().getBody(TransferFileRequest.class);
						boolean success=SCPFrom.transfer(remoteHost, remotePort, remoteUser, remotePassword, 
								message.getSourcePath()+message.getSourceFileName(), message.getDestinationPath()+message.getDestinationFileName());
System.out.println("transfer result is:"+success);
						TransferFileResult response=new TransferFileResult();
						response.setSuccess(success);
						response.setErrorCode(0);
						response.setErrorDescription("success");
						System.out.println("transfer result is:"+success);
						exchange.getOut().setBody(response);
					}
				})
				.otherwise()
				.log("brate, nesto je sjebano");
			}
	
}
