package de.kybeidos.switchyard.sasauto;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.util.Properties;

import javax.inject.Inject;

import org.switchyard.component.bean.Service;

import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelExec;
import com.jcraft.jsch.JSch;

import de.kybeidos.switchyard.sasauto.interfaces.ConnectionSettingsService;
import de.kybeidos.switchyard.sasauto.interfaces.SSHexecInterface;
import de.kybeidos.switchyard.sasauto.model.ConnectionSettings;
import de.kybeidos.switchyard.sasauto.model.ExecutionRequest;
import de.kybeidos.switchyard.sasauto.model.ExecutionResult;
import javax.inject.Named;


@Service(SSHexecInterface.class)
public class SSHexecService implements SSHexecInterface {

	@Inject @Named("connectionSettingsServiceBean")
	private ConnectionSettingsService connectionSettingsServiceBean;
	
	@Override
	public ExecutionResult exec(ExecutionRequest request) {
		request =connectionSettingsServiceBean.addDefaults(request);
		ConnectionSettings connection=request.getConnectionSettings();
		// TODO Auto-generated method stub
		System.out.println("started the SSH execution");
		ExecutionResult exR=new ExecutionResult();
		String sshHost = connection.getHostname();
		Integer sshPort = connection.getPortNumber();
		String sshUserName = connection.getUsername();
		String sshPassword = connection.getPwd();
		String sshCommand =request.getCommand();

		
		
		if (sshHost==null || sshPort==null ||
				sshUserName==null || sshPassword==null ||
				sshCommand==null){
			exR.setOutput("Inputs are null");
			exR.setSuccess(false);
			return exR;
		}
		
		InputStream in = null;
		ByteArrayOutputStream erOs=new ByteArrayOutputStream();
		StringBuilder out=new StringBuilder();
		com.jcraft.jsch.Session jschsess = null;

		try {
		JSch jsch = new JSch();
		Properties conf = new Properties();
		conf.put("StrictHostKeyChecking", "no");
		jschsess = jsch.getSession( sshUserName , sshHost);
		jschsess.setConfig(conf);
		jschsess.setPort(sshPort);
		jschsess.setPassword(sshPassword);
		jschsess.connect();
		Channel channel = jschsess.openChannel("exec");
		((ChannelExec)channel).setPty(true);
		((ChannelExec)channel).setCommand(sshCommand);
		channel.setInputStream(null);
		((ChannelExec)channel).setErrStream(erOs);
		in=channel.getInputStream();
		channel.connect();
		byte[] tmp = new byte[1024];
		while (true) {
		        while (in.available() > 0) {
		            int i = in.read(tmp, 0, 1024);
		            if (i < 0){
		                break;
		                }
		             out.append(new String(tmp,0,i));
		        }
		        if (channel.isClosed()) {
		             if(in.available() > 0) {
		                int i = in.read(tmp, 0, 1024);
		                out.append(new String(tmp,0,i));
		             }
		             if (channel.getExitStatus() == 0) {
		            	 exR.setSuccess(true);
		             }
		             else {
		            	 exR.setSuccess(false);
		            	 out.append("ERROR:").append(new String(erOs.toByteArray(),0,1024));
		             }
		            break;
		           }
		        try {
		            Thread.sleep(1000);
		              } catch (Exception ee) {}
		       }
		channel.disconnect();
		        jschsess.disconnect();
		} catch (Exception e) {
			e.printStackTrace();
			exR.setSuccess(false);
       	 out.append("ERROR:").append(new String(erOs.toByteArray()));
		}
		exR.setOutput(out.toString());
		return exR;
	}
	
//	private void getProperties(){
//		JasyptPropertiesParser jasypt = new JasyptPropertiesParser();
//		// and set the master password
//		jasypt.setPassword("kybeidos2013");
//		PropertiesComponent pc = new PropertiesComponent();
//		pc.setLocation("connection.properties");
//		//classpath:de/kybeidos/switchyard/sasauto/
//		pc.setPropertiesParser(jasypt);
//		context.addComponent("properties", pc);		
//	}

}
