package de.kybeidos.switchyard.sasauto.test;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.cdi.CDIMixIn;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;

import de.kybeidos.switchyard.sasauto.model.TransferFileRequest;
import de.kybeidos.switchyard.sasauto.model.TransferFileResult;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(mixins = CDIMixIn.class, config = SwitchYardTestCaseConfig.SWITCHYARD_XML)
public class FileTransferDownloadTest {

	@ServiceOperation("FileTransfer")
	private Invoker service;

	@Test
	public void testTransferFile() throws Exception {
		// TODO Auto-generated method stub
		// initialize your test message
		TransferFileRequest message = new TransferFileRequest();
		message.setTransferType("download");
		message.setSourcePath("");
		message.setSourceFileName("sale");
		message.setDestinationPath("/Users/aleksandarkovacevic/");
		message.setDestinationFileName("saleDownloadedtest");
		TransferFileResult result = service.operation("transferFile")
				.sendInOut(message).getContent(TransferFileResult.class);
		System.out.println("result: "+result.isSuccess()+":"+result.getErrorDescription());
		Assert.assertTrue(result.isSuccess());

	}

}
