package de.kybeidos.switchyard.sasauto.test;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.cdi.CDIMixIn;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;

import de.kybeidos.switchyard.sasauto.model.ExecutionRequest;
import de.kybeidos.switchyard.sasauto.model.ExecutionResult;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(mixins = CDIMixIn.class, config = SwitchYardTestCaseConfig.SWITCHYARD_XML)
public class ServiceCommandExecuteTest {

	@ServiceOperation("ServiceCommand")
	private Invoker service;

	@Test
	public void testDoCommand1() throws Exception {
		// initialize your test message
		ExecutionRequest message = new ExecutionRequest();
		message.setCommand("ls -lR");
		message.setConnectionSettings(null); // let the connectionSettings be filled with default values
		message.setServiceCommand("execute");
		ExecutionResult result = service.operation("doExecute")
				.sendInOut(message).getContent(ExecutionResult.class);
		
		System.out.println("Received output: "+result.getOutput());
		// validate the results
		Assert.assertTrue(result.isSuccess());
	}

	@Test
	public void testDoCommand2() throws Exception {
		// initialize your test message
		ExecutionRequest message = new ExecutionRequest();
		message.setCommand("ifconfig");
		message.setConnectionSettings(null); // let the connectionSettings be filled with default values
		message.setServiceCommand("execute");
		ExecutionResult result = service.operation("doExecute")
				.sendInOut(message).getContent(ExecutionResult.class);

		System.out.println("Received output: "+result.getOutput());
		// validate the results
		Assert.assertTrue(result.isSuccess());
	}

	
}
